type OpenRoomRequest:void {
	.username:string
	.roomName:string
}

type PublishRequest:void {
	.message:string
	.username:string
	.roomName:string
}

type GetHistory:void {
	.roomName:string
}

type EnterRoomRequest:void {
	.location:string
	.roomName:string
}

interface ChatInterface {
RequestResponse:
	openRoom(OpenRoomRequest)(void),
	publish(PublishRequest)(void),
	getHistory(GetHistory)(string),
	enterRoom(EnterRoomRequest)(void)
}

interface ClientInterface {
OneWay:
	update(PublishRequest)
}
