include "../advanced_chat/chat.iol"
include "console.iol"
include "../authenticator/authenticator.iol"

interface ShutdownInterface {
OneWay: shutdown(void)
}

outputPort Chat {
Location: "socket://localhost:8000/"
Protocol: sodep
Interfaces: ChatInterface
}

outputPort Authenticator {
Location: "socket://localhost:9000/"
Protocol: sodep
Interfaces: AuthenticatorInterface
}

type ApiKey:void {
	.apiKey:string
}

interface extender ApiKeyExtender {
RequestResponse:
	*(ApiKey)(void) throws InvalidApiKey
}

inputPort Network {
Location: "socket://localhost:8010/"
Protocol: http
Aggregates: Chat with ApiKeyExtender
Interfaces: ShutdownInterface
}

embedded {
Jolie:
	"../authenticator/main.ol"
}

courier Network {
	[ interface ChatInterface( request )( response ) ] {
		auth@Authenticator( request.apiKey )();
		forward( request )( response )
	}
}

main
{
	shutdown()
}